!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
!~~~~~                        CONVERT                        vs 3D 05    ~~~~~!
!
! per convertire i file nel formato di POM in formato binario    
!
! chiama le sr SRinterp per avere UA, VA, U e V sulla griglia dell'elevazione
! e SIGMAtoZ che interpola tra i livelli sigma per ottenere quelli zeta
!
! 28/11/01=>modifiche per scrivere file pi� piccoli per il mode 2 e riordino
!             del file
! 14/12/01=>convertibile per unix (metti/togli commenti prima riga)
! 12/02/14=>VB: remove convertion to grads and other modifications
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      PROGRAM MAIN
      

!WWWWW
        logical*4 dummyL4,Cinterpol,CbordoS,CintSIGMA
        integer*4 dummyI4,dummyI4b
        PARAMETER (iFM2Dt=1,iFM2D1=18,iFM3D1=17)
        DIMENSION  myPROF(12)
	DATA undef/9999.9/,zeroH/1./,KE/12/,terra/1./
      !&     myPROF/-1,-10,-20,-30,-50,-100,-150,-200,
      !&            -300,-330,-350,-370/
     $     ,myPROF/-1,-10,-20,-30,-50,-100,-200,-300
     $            ,-400,-450,-470,-490/
      !&     myPROF/-10,-50,-100,-200,-500,-1000,-2000,-3000,
      !&            -3500,-4000,-4250,-4750/

      CHARACTER*15 dataini
      CHARACTER*2  CODsim
      CHARACTER*3  recNUMsim
      CHARACTER*8  fileIN,fileOUT,fileOUT2,fileOUT3,
     1             files2Dt(iFM2Dt),files2D1(iFM2D1),files3D1(iFM3D1)

      CHARACTER*12 datadirIN
      CHARACTER*13 datadirOUT
      CHARACTER*13 datadirOUT2

!      REAL*8     KM   [allocatable](:,:,:,:)      
      
      REAL, allocatable :: ZZ(:)
     $
     $          , H2D(:,:),FSM(:,:)
     $
     $          ,A2Dt(:,:,:)
     $          ,   H(:,:,:)
     $
     $          ,A2D1 (:,:,:)
     $          ,AAM2D(:,:,:)
     $          ,ADVUA(:,:,:),ADVVA(:,:,:) 
     $          ,ADX2D(:,:,:),ADY2D(:,:,:) 
     $          ,COR  (:,:,:),D    (:,:,:)
     $          ,DRX2D(:,:,:),DRY2D(:,:,:)
     $          ,ELB  (:,:,:)
     $          ,UAB  (:,:,:),VAB  (:,:,:)
     $          ,WUBOT(:,:,:),WVBOT(:,:,:) 
     $          ,WUSUR(:,:,:),WVSUR(:,:,:)
     $          ,WTSUR(:,:,:),WSSUR(:,:,:)
     $
     $          ,A3D(:,:,:)  ,A3Dsig(:,:,:)
     $          ,A3Dlev(:,:) ,A3D1sig(:,:,:,:)
     $
     $          ,A3D1 (:,:,:,:)
     $          ,AAM  (:,:,:,:)
     $          ,ADVX (:,:,:,:),ADVY (:,:,:,:)
     $          ,CURV (:,:,:,:),L    (:,:,:,:)
     $          ,DRHOX(:,:,:,:),DRHOY(:,:,:,:)
     $          ,KH   (:,:,:,:),KM   (:,:,:,:)
     $          ,Q2   (:,:,:,:),Q2L  (:,:,:,:)
     $          ,RHO  (:,:,:,:)
     $          ,SB   (:,:,:,:),TB   (:,:,:,:)
     $          ,UB   (:,:,:,:),VB   (:,:,:,:)
     $          ,W    (:,:,:,:)
*-----------------------------------------------------------------------------*

      datadirIN = '../POM_DATA/'
      datadirOUT= '../POM_GRADS/' 
      datadirOUT2='../pomMATLAB/' 



!WWWWW

      write(*,*)
      write(*,*) 
      write(*,*)
      write(*,*) 
      write(*,*) '************************************************'
      write(*,*) '*******        CONVERT       vs 3D 05   ********'
      write(*,*) '************************************************'
      write(*,*)
      write(*,*) 

*DDDDD
      write(*,*) 'DX?'
	read(*,*) DX
      write(*,*) 'DY?'
	read(*,*) DY
      write(*,*) 'codice simulazione?'
	read(*,*) CODsim
      write(*,*) 'numero simulazione?'
	read(*,*) recNUMsim
	Cinterpol = .true.
	CbordoS = .true.
	CintSIGMA = .true.    

	outMATLAB=1

*DDDDD

      files2Dt(1) ='H____'//recNUMsim

	files2D1(1) ='AAM2D'//recNUMsim 
	files2D1(2) ='ADVUA'//recNUMsim 
	files2D1(3) ='ADVVA'//recNUMsim 
	files2D1(4) ='ADX2D'//recNUMsim 
	files2D1(5) ='ADY2D'//recNUMsim 
        files2D1(6) ='COR__'//recNUMsim
	files2D1(7) ='D____'//recNUMsim
	files2D1(8) ='DRX2D'//recNUMsim 
	files2D1(9) ='DRY2D'//recNUMsim 
        files2D1(10)='ELB__'//recNUMsim
        files2D1(11)='UAB__'//recNUMsim
        files2D1(12)='VAB__'//recNUMsim
	files2D1(13)='WUBOT'//recNUMsim 
	files2D1(14)='WVBOT'//recNUMsim 
	files2D1(15)='WUSUR'//recNUMsim 
	files2D1(16)='WVSUR'//recNUMsim 
	files2D1(17)='WTSUR'//recNUMsim 
	files2D1(18)='WSSUR'//recNUMsim 
	
	files3D1(1) ='AAM__'//recNUMsim
	files3D1(2) ='ADVX_'//recNUMsim 
	files3D1(3) ='ADVY_'//recNUMsim 
	files3D1(4) ='CURV_'//recNUMsim
	files3D1(5) ='DRHOX'//recNUMsim
	files3D1(6) ='DRHOY'//recNUMsim
	files3D1(7) ='KH___'//recNUMsim
	files3D1(8) ='KM___'//recNUMsim 
	files3D1(9) ='L____'//recNUMsim 
	files3D1(10)='Q2___'//recNUMsim
	files3D1(11)='Q2L__'//recNUMsiM
	files3D1(12)='RHO__'//recNUMsim
	files3D1(13)='SB___'//recNUMsiM
	files3D1(14)='TB___'//recNUMsim
	files3D1(15)='UB___'//recNUMsiM
	files3D1(16)='VB___'//recNUMsim
	files3D1(17)='W____'//recNUMsiM


       fileOUT2='r2D'//CODsim//recNUMsim    
       fileOUT3='r3D'//CODsim//recNUMsim 

  210 FORMAT(5X,6(2X,E12.5))  
!-----------------------------------------------------------------------------!
      fileIN='repor'//recNUMsim             
      open(1,file=datadirIN//fileIN//'.txt',status='old') 
      read(1,*)
	read(1,*)
	read(1,'(9X,I10)')MODE
	read(1,*)
	read(1,'(9X,I10,11X,I10,11X,I10)')IM,JM,KB
      read(1,*)
	read(1,*)
	read(1,'(9X,F10.5,11X,I10)') DAYS,iEND
      read(1,'(9X,F10.5,11X,I10)') PRTD1,iPRINT
      close(1)
	
!-----
      iTMAX=INT(iEND/iPRINT)+1
	IF(CintSIGMA.eqv..false.)THEN
	  KE=KB
      ENDIF
      
      write(*,*)'allocazione matrici' 
            
      ALLOCATE(A2Dt(1:IM,1:JM,1:iTMAX))
      ALLOCATE(   H(1:IM,1:JM,1:iTMAX)) 
      ALLOCATE( H2D(1:IM,1:JM)) 
      
      ALLOCATE(A2D1 (1:IM,1:JM,1:iTMAX))

      ALLOCATE(ELB  (1:IM,1:JM,1:iTMAX))
      ALLOCATE(UAB  (1:IM,1:JM,1:iTMAX))
      ALLOCATE(VAB  (1:IM,1:JM,1:iTMAX))

      ALLOCATE(WUSUR(1:IM,1:JM,1:iTMAX))
      ALLOCATE(WVSUR(1:IM,1:JM,1:iTMAX))


      ALLOCATE(ZZ(1:KB))
      ALLOCATE(FSM(1:IM,1:JM))
      ALLOCATE(A3D(1:IM,1:JM,1:KE))
      ALLOCATE(A3Dlev (1:IM,1:JM))
      ALLOCATE(A3Dsig (1:IM,1:JM,1:KB))
      ALLOCATE(A3D1sig(1:IM,1:JM,1:KB,1:iTMAX))

      if(MODE.eq.2) goto 678

      ALLOCATE(A3D1 (1:IM,1:JM,1:KE,1:iTMAX))

      ALLOCATE(SB   (1:IM,1:JM,1:KE,1:iTMAX))
      ALLOCATE(TB   (1:IM,1:JM,1:KE,1:iTMAX))
      ALLOCATE(UB   (1:IM,1:JM,1:KE,1:iTMAX))
      ALLOCATE(VB   (1:IM,1:JM,1:KE,1:iTMAX))
      ALLOCATE(W    (1:IM,1:JM,1:KE,1:iTMAX))

 678  continue
!-----
	!Read the vector ZZ from sig3D***.txt
	fileIN='sig3D'//recNUMsim 
	open(26,file=datadirIN//fileIN//'.txt',status='old')
99998     FORMAT(16X,F10.3)
          read(26,*)
		read(26,*)
		read(26,*)
          do 11 k=1,KB
   11       read(26,99998) ZZ(K)
      close(26)

!**** Reading 2D matrix  *****************************************************

      write(*,*)'lettura matrici 2D'


      DO iFILE2Dt=1,iFM2Dt
      fileIN=files2Dt(iFILE2Dt)
             
      open(1,file=datadirIN//fileIN//'.pom',status='old')
      read(1,*)!!! skip data
      read(1,*)!!! initials

      read(1,*)!!! label
      read(1,*)!!! time,scale
      iNUMcol=0 
101   continue
      read(1,*)!!! indexes
      iNUMcolNEW=iNUMcol+6
      do J=JM,1,-1
        read(1,210) (A2Dt(i,j,1), I=iNUMcol+1,iNUMcolNEW)
      enddo
      iresto=IM-iNUMcolNEW
      iNUMcol=iNUMcolNEW
      IF(iresto.eq.0)goto 102
      IF(iresto.ge.6)THEN   
        goto  101
      ELSE 
        read(1,*)!!! indexes
        do J=JM,1,-1
          read(1,210) (A2Dt(i,j,1), I=iNUmcol+1,IM)
        enddo 
        goto 102                             
      ENDIF    
102   continue 
      close(1)               
      
!**** 2D variable assigment
      
      IF(files2Dt(iFILE2Dt).eq.'H____'//recNUMsim) THEN
        do j=1,JM
         do i=1,IM
           H(i,j,1)=A2Dt(i,j,1)
           H2D(i,j)=A2Dt(i,j,1)  !for sr SIGMAtoZ
	     if(H(i,j,1).eq.terra) then
		   FSM(i,j)=0.
	     else
	       FSM(i,j)=1.
		 endif
	   enddo
        enddo
	ENDIF

      do j=1,JM
       do i=1,IM
        do it=2,iTMAX
          H(i,j,it)=H(i,j,1)
	  enddo
	 enddo
      enddo

	
      ENDDO !on iFILE2Dt

!**** Reading 2D+t matrix ****************************************************

      write(*,*)'lettura matrici 2D+t'


      DO iFILE2D1=1,iFM2D1

	if(iFILE2D1.eq. 1)cycle !AAM2D
	if(iFILE2D1.eq. 2)cycle !ADVUA
	if(iFILE2D1.eq. 3)cycle !ADVVA
	if(iFILE2D1.eq. 4)cycle !ADX2D
	if(iFILE2D1.eq. 5)cycle !ADY2D
	if(iFILE2D1.eq. 6)cycle !COR
	if(iFILE2D1.eq. 7)cycle !D
	if(iFILE2D1.eq. 8)cycle !DRX2D
	if(iFILE2D1.eq. 9)cycle !DRY2D
      
	if(iFILE2D1.eq.13)cycle !WUBOT
	if(iFILE2D1.eq.14)cycle !WVBOT
	
	if(iFILE2D1.eq.17)cycle !WTSUR
	if(iFILE2D1.eq.18)cycle !WSSUR

      fileIN=files2D1(iFILE2D1)
      
      open(2,file=datadirIN//fileIN//'.pom',status='old') 
      read(2,*)!!! skip data 
      read(2,*)!!! initials

      do it=1,iTMAX
         read(2,*)!!! label
         read(2,*)!!! time,scale
         iNUMcol=0   
1003    continue
         read(2,*)!!! initials
         iNUMcolNEW=iNUMcol+6  
         do J=JM,1,-1
            read(2,210) (A2D1(i,j,it), I=iNUMcol+1,iNUMcolNEW)  
         enddo
         iresto=IM-iNUMcolNEW
         iNUMcol=iNUMcolNEW
         IF(iresto.eq.0)goto 1004   
         IF(iresto.ge.6)THEN   
           goto  1003
         ELSE 
           read(2,*)!!! initials
           do J=JM,1,-1
              read(2,210) (A2D1(i,j,it), I=iNUmcol+1,IM)
           enddo 
           goto 1004    
         ENDIF
1004    continue     
      enddo
      close(2)
      
!****  2D+t variable assigment
	!AAM2D
      IF(fileIN.eq.'AAM2D'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
              AAM2D(i,j,it)=A2D1(i,j,it)
            ELSE
              AAM2D(i,j,it)=undef
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!ADVUA
      IF(fileIN.eq.'ADVUA'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN

            ELSE

            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!ADVVA
      IF(fileIN.eq.'ADVVA'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN

            ELSE

            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!ADX2D
      IF(fileIN.eq.'ADX2D'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN

            ELSE

            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!ADY2D
      IF(fileIN.eq.'ADY2D'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN

            ELSE

            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!COR
      IF(fileIN.eq.'COR__'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
              COR(i,j,it)=A2D1(i,j,it)
            ELSE
              COR(i,j,it)=undef
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!D
      IF(fileIN.eq.'D____'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
              D(i,j,it)=A2D1(i,j,it)
            ELSE
              D(i,j,it)=undef
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!DRX2D
      IF(fileIN.eq.'DRX2D'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN

            ELSE

            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!DRY2D
      IF(fileIN.eq.'DRY2D'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN

            ELSE

            ENDIF
          enddo
         enddo
        enddo 
	ENDIF     
	!ELB
      IF(fileIN.eq.'ELB__'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM   
            IF(H(i,j,1).ne.terra)THEN
              ELB(i,j,it)=A2D1(i,j,it)
            ELSE
              ELB(i,j,it)=undef
            ENDIF               
          enddo
         enddo
        enddo  
      ENDIF
	!UAB
      IF(fileIN.eq.'UAB__'//recNUMsim) THEN
	if(Cinterpol)then
	  write(*,*) '               interpolazione UAB'

	  call interUAB(IM,JM,iTMAX,A2D1,UAB,H,recNUMSIM,DX,DY,CbordoS)
	else
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM   
            IF(H(i,j,1).ne.terra)THEN
              UAB(i,j,it)=A2D1(i,j,it)
            ELSE
              UAB(i,j,it)=undef
            ENDIF               
	    enddo
	   enddo
	  enddo
	endif
	ENDIF
	!VAB
      IF(fileIN.eq.'VAB__'//recNUMsim) THEN
	if(Cinterpol)then
	  write(*,*) '               interpolazione VAB'

 	  call interVAB(IM,JM,iTMAX,A2D1,VAB,H,recNUMSIM,DX,DY,CbordoS)
      else
	  do it=1,iTMAX
         do j=1,JM
          do i=1,IM   
            IF(H(i,j,1).ne.terra)THEN
             VAB(i,j,it)=A2D1(i,j,it)
            ELSE
              VAB(i,j,it)=undef
            ENDIF               
          enddo
         enddo
        enddo
	endif
      ENDIF
	!WUBOT
      IF(fileIN.eq.'WUBOT'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
            
            ELSE
              
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!WVBOT
      IF(fileIN.eq.'WVBOT'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
             
            ELSE
              
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!WUSUR
      IF(fileIN.eq.'WUSUR'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
              WUSUR(i,j,it)=A2D1(i,j,it)
            ELSE
              WUSUR(i,j,it)=undef
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!WVSUR
      IF(fileIN.eq.'WVSUR'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
              WVSUR(i,j,it)=A2D1(i,j,it)
            ELSE
              WVSUR(i,j,it)=undef
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!WTSUR
      IF(fileIN.eq.'WTSUR'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
             
            ELSE
            
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
	!WSSUR
      IF(fileIN.eq.'WSSUR'//recNUMsim) THEN
        do it=1,iTMAX
         do j=1,JM
          do i=1,IM
            IF(H(i,j,1).ne.terra)THEN
             
            ELSE
              
            ENDIF
          enddo
         enddo
        enddo      
      ENDIF
                                                       
      ENDDO  !!!on iFILE2D1

	IF(MODE.eq.2) goto 88888
!**** Reading 3D+t matrix ****************************************************

      write(*,*)'lettura matrici 3D+t'


      DO iFILE3D1=1,iFM3D1

	if(iFILE3D1.eq. 1)cycle !AAM
	if(iFILE3D1.eq. 2)cycle !ADVX
	if(iFILE3D1.eq. 3)cycle !ADVY
	if(iFILE3D1.eq. 4)cycle !CURV
	if(iFILE3D1.eq. 5)cycle !DRHOX
	if(iFILE3D1.eq. 6)cycle !DRHOY
	if(iFILE3D1.eq. 7)cycle !KH
	if(iFILE3D1.eq. 8)cycle !KM
	if(iFILE3D1.eq. 9)cycle !L
	if(iFILE3D1.eq.10)cycle !Q2
	if(iFILE3D1.eq.11)cycle !Q2L
	if(iFILE3D1.eq.12)cycle !RHO
	

      fileIN=files3D1(iFILE3D1)

      open(3,file=datadirIN//fileIN//'.pom',status='old') 
      read(3,*)!!! skip data 
      read(3,*)!!! initials

      DO it=1,iTMAX
         read(3,*)!!! label
         read(3,*)!!! time,scale

	 do k=1,KB
	 read(3,*)!!! layer
       iNUMcol=0   
10003  continue
       read(3,*)!!! iniitials
       iNUMcolNEW=iNUMcol+6  

         do J=JM,1,-1
            read(3,210) (A3D1sig(i,j,k,it), I=iNUMcol+1,iNUMcolNEW)  
         enddo
         iresto=IM-iNUMcolNEW
         iNUMcol=iNUMcolNEW
         IF(iresto.eq.0)goto 10004   
         IF(iresto.ge.6)THEN   
           goto  10003
         ELSE 
           read(3,*)!!! initials
           do J=JM,1,-1
              read(3,210) (A3D1sig(i,j,k,it), I=iNUmcol+1,IM)
           enddo 
           goto 10004    
         ENDIF
10004    continue     
	 enddo

	!Interpolation on the vertical
	IF(CintSIGMA)THEN
	
	

	do ksig=1,KB
	  do i=1,IM
	  do j=1,JM
	    A3Dsig(i,j,ksig)=A3D1sig(i,j,ksig,it)
	  enddo
	  enddo
	enddo
	
	do ibat=1,KE
	  ZLEV=myPROF(ibat)
	  call SIGMAtoZ(ZZ,H2D,A3Dsig,A3Dlev,ZLEV,FSM,IM,JM,KB)
	  do i=1,IM
	  do j=1,JM
	    if( (iFILE3D1.eq.15.or.iFILE3D1.eq.16).or.  !skip U and V
     & 	   myPROF(ibat).ge.-H(i,j,1))then
	      A3D(i,j,ibat)=A3Dlev(i,j)
	    else
	      A3D(i,j,ibat)=undef
	    endif
	  enddo
	  enddo
	enddo

	do k=1,KE
	 do i=1,IM
	  do j=1,JM
	    A3D1(i,j,k,it)=A3D(i,j,k)
	  enddo
	 enddo
	enddo

	ELSE

	do k=1,KE
	 do i=1,IM
	  do j=1,JM
	    A3D1(i,j,k,it)=A3D1sig(i,j,k,it)
	  enddo
	 enddo
	enddo

	ENDIF

      ENDDO !su it
      close(3)
!****  3D+t variable assigment
	!AAM
      IF(fileIN.eq.'AAM__'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               AAM(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               AAM(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!ADVX
      IF(fileIN.eq.'ADVX_'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN

             ELSE

             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!ADVY
      IF(fileIN.eq.'ADVY_'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN

             ELSE

             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!CURV
      IF(fileIN.eq.'CURV_'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               CURV(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               CURV(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!DRHOX
      IF(fileIN.eq.'DRHOX'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN

             ELSE

             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!DRHOY
      IF(fileIN.eq.'DRHOY'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN

             ELSE

             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!KH
      IF(fileIN.eq.'KH___'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               KH(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               KH(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!KM
      IF(fileIN.eq.'KM___'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               KM(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               KM(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!L
      IF(fileIN.eq.'L____'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               L(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               L(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!Q2
      IF(fileIN.eq.'Q2___'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               Q2(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               Q2(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!Q2L
      IF(fileIN.eq.'Q2L__'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               Q2L(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               Q2L(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!RHO
      IF(fileIN.eq.'RHO__'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               RHO(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               RHO(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!SB
      IF(fileIN.eq.'SB___'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               SB(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               SB(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!TB
      IF(fileIN.eq.'TB___'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               TB(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               TB(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF
	!UB
      IF(fileIN.eq.'UB___'//recNUMsim) THEN
	if(Cinterpol)then
	  write(*,*) '               interpolazione UB'

	  call interUB(IM,JM,KE,iTMAX,A3D1,UB,H,recNUMSIM,DX,DY
     &               ,CbordoS,myPROF)
	else
	  do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               UB(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               UB(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
	endif
      ENDIF
	!VB
      IF(fileIN.eq.'VB___'//recNUMsim) THEN
	if(Cinterpol)then
	  write(*,*) '               interpolazione VB'

	  call interVB(IM,JM,KE,iTMAX,A3D1,VB,H,recNUMSIM,DX,DY
     &               ,CbordoS,myPROF)
	else
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               VB(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               VB(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
	endif
      ENDIF
	!W
      IF(fileIN.eq.'W____'//recNUMsim) THEN
        do it=1,iTMAX
	   do k=1,KE
          do j=1,JM
           do i=1,IM   
             IF(H(i,j,1).ne.terra)THEN
               W(i,j,k,it)=A3D1(i,j,k,it)
             ELSE
               W(i,j,k,it)=undef
             ENDIF               
           enddo
          enddo
         enddo
        enddo
      ENDIF


      ENDDO  !!!on iFILE3D1

88888 continue

     

      if(outMATLAB.eq.1)then

!******************   Writting file for MATLAB   *************************

      !2D+t matrix                                    
      write(*,*) 'scrittura file '//fileOUT2//'.txt'

      open(98,file=datadirOUT2//fileOUT2//'.txt',status='new') !,form='formatted',recordType='stream',status='new')

      DO it=1,iTMAX
        do i=1,IM
         do j=1,JM
          write(98,'(3i5,4F16.6)')i,j,it,H(i,j,it),
     &                            ELB(i,j,it),UAB(i,j,it),VAB(i,j,it)
        enddo
       enddo
      ENDDO
      
      close(98)

      !3D+t matrix                                    
      if(MODE.ne.2)then
      write(*,*) 'scrittura file '//fileOUT3//'.txt'

      open(99,file=datadirOUT2//fileOUT3//'.txt') !,form='formatted',
    ! &        recordType='stream',status='new')

      DO it=1,iTMAX
        do i=1,IM
         do j=1,JM
          do k=1,KE
           write(99,'(4i5,5F16.6)')i,j,k,it,
     &                           UB(i,j,k,it),VB(i,j,k,it),W(i,j,k,it),
     &                           TB(i,j,k,it),SB(i,j,k,it)
          enddo
         enddo
        enddo
      ENDDO

      close(99)

      endif!(MODE.ne.2)

      endif!(outMATLAB.eq.1)
!*****



	STOP
      END
*******************************************************************************
