!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      PROGRAM CONVERTLAMP
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      
      REAl*4, allocatable :: CONC(:,:,:)
     $          ,ULAMP(:,:,:)
     $          ,VLAMP(:,:,:)
     $          ,WLAMP(:,:,:)


      character*8 label
      character*12 datadirIN
      character*13 datadirOUT

      real undef
      character*8 fileIN
      character*8 fileOUT
      character*3 recNUMsim,cIOLAMP,cJOLAMP
      integer ierror
!------------------------------------------------------------------------!

      datadirIN='../POM_DATA/'
      datadirOUT='../pomMATLAB/'
!FA&PO
      write(*,*) '************************************************'
      write(*,*) '******     CONVERTLAMP       (FA & PO)   *******'
      write(*,*) '************************************************'

      write(*,*) ‘Simulation number?’
      read(*,*) recNUMsim

      write(*,*) 'IOLAMP?'
      read(*,*) cIOLAMP
      write(*,*) 'JOLAMP?'
      read(*,*) cJOLAMP
      

      fileIN='repor'//recNUMsim             
      open(1,file=datadirIN//fileIN//'.txt',status='old') 
       read(1,*)
       read(1,*)
       read(1,'(9X,I10)')MODE
       read(1,*)
       read(1,*)
       read(1,'(9X,I10,11X,I10,11X,I10)))') IM,JM,IO
      read(1,*)
       read(1,'(9X,F10.5,11X,I10)') DAYS,iEND
       read(1,'(9X,F10.5,11X,I10)') PRTD1,iPRINT
      close(1)

      undef=-9999.9

      ALLOCATE(CONC   (1:IM,1:JM,IO:0))
      ALLOCATE(ULAMP  (1:IM,1:JM,IO:0))
      ALLOCATE(VLAMP  (1:IM,1:JM,IO:0))
      ALLOCATE(WLAMP  (1:IM,1:JM,IO:0))

 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      fileIN='CONC_'//recNUMsim        
      open(199,file=datadirIN//fileIN//'.pom',status='old')
      read(199,*)!!! salta dati 
      read(199,*)!!! iniziali

      fileIN='ULAMP'//recNUMsim        
      open(198,file=datadirIN//fileIN//'.pom',status='old')
      read(198,*)!!! salta dati 
      read(198,*)!!! iniziali

      fileIN='VLAMP'//recNUMsim        
      open(197,file=datadirIN//fileIN//'.pom',status='old')
      read(197,*)!!! salta dati 
      read(197,*)!!! iniziali

      fileIN='WLAMP'//recNUMsim        
      open(196,file=datadirIN//fileIN//'.pom',status='old')
      read(196,*)!!! salta dati 
      read(196,*)!!! iniziali

!      fileIN='CONCB'//recNUMsim        
!      open(195,file=datadirIN//fileIN//'.pom',status='old')
!      read(195,*)!!! salta dati 
!      read(195,*)!!! iniziali

      fileOUT='lamp_'//recNUMsim  
      open(99,file=datadirOUT//fileOUT//'.txt')
    ! &        recordType='stream',status='new')

!---------------------------------
210   FORMAT(5X,6(2X,E12.5)) 

      iTMAX=INT(iEND/iPRINT)+1
      WRITE(*,*)'ITMAX=',ITMAX
      do it=1,ITMAX
       write(*,*)'it=',it
               
         read(199,*)            !!! label
         read(199,*)            !!! time,scale

         read(198,*)            !!! label
         read(198,*)            !!! time,scale

         read(197,*)            !!! label
         read(197,*)            !!! time,scale

         read(196,*)            !!! label
         read(196,*)            !!! time,scale

!         read(195,*)            !!! label
!         read(195,*)            !!! time,scale

!matrici 2D+t
!         iNUMcol2D=0 
!1012     continue
!         read(195,*)         !!! indici
!         iNUMcolNEW2D=iNUMcol2D+6 
!         do J=JM,1,-1
!          read(195,210) (CONCB(i,j), I=iNUMcol2D+1,iNUMcolNEW2D)
!         enddo
!         iresto2D=IM-iNUMcolNEW2D
!         iNUMcol2D=iNUMcolNEW2D
!         if(iresto2D.eq.0) goto 1022
!         IF(iresto2D.gt.6)THEN   
!          goto  1012
!         ELSE 
!          read(195,*)
!          do J=JM,1,-1
!           read(195,210) (CONCB(i,j), I=iNUmcol2D+1,IM)
!          enddo
!          goto 1022                             
!         ENDIF    
!1022     continue 

!matrici 3D+t
         do k=0,IO,-1           !FA&PO Inizio ciclo su k
            read(199,*)         !!! layer

            read(198,*)         !!! layer

            read(197,*)         !!! layer

            read(196,*)         !!! layer

            iNUMcol=0 
 101        continue
            read(199,*)         !!! index
            read(198,*)         !!! index
            read(197,*)         !!! index
            read(196,*)         !!! index
            iNUMcolNEW=iNUMcol+6 
            do J=JM,1,-1
               read(199,210) (CONC(i,j,k), I=iNUMcol+1,iNUMcolNEW)

               read(198,210) (ULAMP(i,j,k), I=iNUMcol+1,iNUMcolNEW)

               read(197,210) (VLAMP(i,j,k), I=iNUMcol+1,iNUMcolNEW)

               read(196,210) (WLAMP(i,j,k), I=iNUMcol+1,iNUMcolNEW)
            enddo              !FA&PO finisce il ciclo J=JM,1,-1

            iresto=IM-iNUMcolNEW
            iNUMcol=iNUMcolNEW

            if(iresto.eq.0) goto 102      


            IF(iresto.gt.6)THEN   
               goto  101
            ELSE 

               read(199,*)      !!! indici

               read(198,*)      !!! indici

               read(197,*)      !!! indici

               read(196,*)      !!! indici

               do J=JM,1,-1
                  read(199,210) (CONC(i,j,k), I=iNUmcol+1,IM)

                  read(198,210) (ULAMP(i,j,k), I=iNUmcol+1,IM)

                  read(197,210) (VLAMP(i,j,k), I=iNUmcol+1,IM)

                  read(196,210) (WLAMP(i,j,k), I=iNUmcol+1,IM)
               enddo              !FA&PO finisce il ciclo J=JM,1,-1 

               goto 102                             
            ENDIF    
 102        continue 
         Enddo                  !FA&PO finish cycle on k


!******************   Writing BIN file for GrADS   **********************

!	write(*,*) 'scrittura file '//fileOUT//'.bin'
!	write(10,*) 'scrittura file '//fileOUT//'.bin'

!	do j=JM,1,-1          
!         do i=1,IM            
!           write(99) CONCB(i,j)
!         enddo
!        enddo

         do k=0,IO,-1
            do j=JM,1,-1          
               do i=1,IM  
            write(99,'(4i5,4F16.6)')i,j,k,it,CONC(i,j,k),
     &                          ULAMP(i,j,k),VLAMP(i,j,k), WLAMP(i,j,k)       
                 
               enddo
            enddo
         enddo



      ENDDO                  !FA&PO finish cycle on it
      close(199)                   
      close(198)                   
      close(197)   
      close(196)      
!      close(195)      
      close(99)                   
                                !close all


 
       stop
       end



























