!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
!                 SUBROUTINES per stampare in formato .pom
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      SUBROUTINE PRINTxy(LABEL,TIME,A,IM,ISKP,JM,JSKP)
			     
      DIMENSION A(IM,JM), indX(IM)

      character*8 label
      character*22 datadir
      character*34 fileout
!-----------------------------------------------------------------------------!

      datadir='//SuperLuasso/pomDATA/'                        
      fileout=datadir//label//'.pom'                               
  
  210 format( I3,2X ,6(2X,E12.5))
  209 format('  j;i',6(2X,I12)) !
  
      open(126,file=fileout,status='unknown', access='append')

      write(126,*)'!!! label : ',label 
      write(126,*)'!!! time  : ',time, '       !!! IINT : ',IINT
      iNUMcol=0   

10003  continue
       iNUMcolNEW=iNUMcol+6  
         
	 do i=iNUMcol+1,iNUMcolNEW,Iskp
	    indX(i)=i
	 enddo
	 write(126,209)(indX(i), i=iNUMcol+1,iNUMcolNEW,Iskp)
	   
	 do J=JM,1,-Jskp
          write(126,210) j,(A(i,j), I=iNUMcol+1,iNUMcolNEW,Iskp)
       enddo
       iresto=IM-iNUMcolNEW
       iNUMcol=iNUMcolNEW
	 if(iresto.eq.0) goto 10004
       
	 IF(iresto.gt.6)THEN   
         goto  10003
       ELSE 
         do i=iNUMcol+1,IM,Iskp
	      indX(i)=i
	   enddo
	   write(126,209)(indX(i), i=iNUMcol+1,IM,Iskp)
	   do J=JM,1,-1
            write(126,210) j,(A(i,j), I=iNUmcol+1,IM,Iskp)
         enddo 
         goto 10004   
       ENDIF
10004  continue

      close(126)

      return
      end
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      SUBROUTINE PRINTxyz(LABEL,TIME,iINT,A,IM,ISKP,JM,JSKP,KB)
			     
      DIMENSION A(IM,JM,KB), indX(IM)

      character*8 label
      character*22 datadir
      character*34 fileout
!-----------------------------------------------------------------------------!

      datadir='//SuperLuasso/pomDATA/'                        
      fileout=datadir//label//'.pom'                               
  
  210 format( I3,2X ,6(2X,E12.5))
  209 format('  j;i',6(2X,I12)) !
      open(126,file=fileout,status='unknown', access='append')

      write(126,*)'!!! label : ',label 
      write(126,*)'!!! time  : ',time, '       !!! IINT : ',IINT

	do k=1,KB
	write(126,'(A6,I3)') 'layer=',k
      iNUMcol=0   
10003  continue
       iNUMcolNEW=iNUMcol+6  
         
	 do i=iNUMcol+1,iNUMcolNEW,Iskp
	    indX(i)=i
	 enddo
	 write(126,209)(indX(i), i=iNUMcol+1,iNUMcolNEW,Iskp)
	   
	 do J=JM,1,-Jskp
          write(126,210) j,(A(i,j,k), I=iNUMcol+1,iNUMcolNEW,Iskp)
       enddo
       iresto=IM-iNUMcolNEW
       iNUMcol=iNUMcolNEW
	 if(iresto.eq.0) goto 10004
       
	 IF(iresto.gt.6)THEN   
         goto  10003
       ELSE 
         do i=iNUMcol+1,IM,Iskp
	      indX(i)=i
	   enddo
	   write(126,209)(indX(i), i=iNUMcol+1,IM,Iskp)
	   do J=JM,1,-1
            write(126,210) j,(A(i,j,k), I=iNUmcol+1,IM,Iskp)
         enddo 
         goto 10004   
       ENDIF
10004  continue

	enddo

      close(126)

      return
      end
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!